/*

Access to Single Unix Specification arpa/inet.h

*/

#ifndef _S_INET_H_
#define _S_INET_H_

#if HAVE_CONFIG_H
#include <config.h>
#endif

#define _XOPEN_SOURCE 500

/* FreeBSD likes sys/stat.h and netinet/in.h */
#include <sys/stat.h>
#include <netinet/in.h>
#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif
#include "../supportc/eiffel.h"


/* functions */

EIF_POINTER posix_inet_ntoa(EIF_POINTER in);


/* struct in_addr */

EIF_INTEGER posix_in_addr_size();

EIF_INTEGER posix_in_addr_s_addr(struct in_addr *p);

void posix_set_in_addr_s_addr(struct in_addr *p, EIF_INTEGER my_s_addr);


#endif /* _S_INET_H_ */
